unit uLoadSave;

interface

uses
  SysUtils, Forms, Dialogs, uDefs;

  procedure LoadGame(out Grille: TGrille; out Score: TScore;
                     out Jeton: TJeton; out IA: Boolean);
  procedure SaveGame(G: TGrille; S: TScore; J: TJeton; IA: Boolean);
  function GameSavedExists: Boolean;

implementation

//------------------------------------------------------------------------------
// Vrifier la prsence d'un fichier de sauvegarde
//------------------------------------------------------------------------------
function GameSavedExists: Boolean;
begin
  result := FileExists(ExtractFilePath(Application.ExeName) + 'P4.sav');
end;
//------------------------------------------------------------------------------
// Sauvegarde de la partie
//------------------------------------------------------------------------------
procedure SaveGame(G: TGrille; S: TScore; J: TJeton; IA: Boolean);
var
  F: File of ShortInt;
  Col, Row: Byte;
  siIA: ShortInt;
begin
  if IA then siIA := -1 else siIA := 0;

  AssignFile(F, ExtractFilePath(Application.ExeName) + 'P4.sav');
  try
    Rewrite(F);
    try
      Write(F, J.X, J.Y, J.Joueur);   // Dernier jeton jou
      Write(F, S[JAUNE], S[ROUGE]);   // Scores
      Write(F, NbManches);            // Nb Manches
      Write(F, siIA);                 // IA oui/non
      for Col := 0 to MAX_COL do      // Grille
        for Row := 0 to MAX_ROW do
          Write(F, G[Col, Row]);
      MessageDlg('Sauvergarde de la partie effectue.',
                 mtInformation, [mbOK], 0);
    except
      raise Exception.Create('Erreur pendant la procdure de sauvergarde');
    end;
  finally
    CloseFile(F);
  end;
end;
//------------------------------------------------------------------------------
// Chargement de la dernire partie sauvegarde
//------------------------------------------------------------------------------
procedure LoadGame(out Grille: TGrille; out Score: TScore;
                   out Jeton: TJeton; out IA: Boolean);
var
  F: File of ShortInt;
  Col, Row: Byte;
  siIA: ShortInt;
begin
  IOResult;
  FileMode := fmOpenRead;
  AssignFile(F, ExtractFilePath(Application.ExeName) + 'P4.sav');
  try
    Reset(F);
    try
      Read(F, Jeton.X, Jeton.Y, Jeton.Joueur);
      Read(F, Score[JAUNE], Score[ROUGE]);
      Read(F, NbManches);
      Read(F, siIA);
      IA := (siIA = -1);
      for Col := 0 to MAX_COL do
        for Row := 0 to MAX_ROW do
          Read(F, Grille[Col, Row]);
    except
      raise Exception.Create('Erreur pendant la procdure de restauration');
    end;
  finally
    CloseFile(F);
  end;

end;

end.
