unit uMain;

{$I P4.inc}

interface

uses
  SysUtils, Forms, Menus, Classes, ActnList, StdCtrls, Controls, ExtCtrls,
  Graphics, Grids, Types, Messages, uDefs;

type
  TFormMain = class(TForm)
    ImageTour: TImage;
    PanelGrille: TPanel;
    Grille: TDrawGrid;
    PanelInfo: TPanel;
    PanelTour: TPanel;
    lblTour: TLabel;
    actList: TActionList;
    mMenu: TMainMenu;
    actQuit: TAction;
    actNew: TAction;
    Jeu1: TMenuItem;
    Nouvellepartie1: TMenuItem;
    Quitter1: TMenuItem;
    act2Joueurs: TAction;
    act1Joueur: TAction;
    Options1: TMenuItem;
    N1JoueurIA1: TMenuItem;
    N2Joueurs1: TMenuItem;
    lblScore: TLabel;
    lblJoueurJaune: TLabel;
    lblJoueurRouge: TLabel;
    lblScoreJaune: TLabel;
    lblScoreRouge: TLabel;
    lblNbManches: TLabel;
    N3: TMenuItem;
    Nombredemanches1: TMenuItem;
    act2Manches: TAction;
    act3Manches: TAction;
    Aumeilleurde3manches1: TMenuItem;
    Aumeilleurde5manches1: TMenuItem;
    act4Manches: TAction;
    Aumeilleurde7manches1: TMenuItem;
    actSave: TAction;
    actLoad: TAction;
    N1: TMenuItem;
    Ouvrirladernirepartieenregistre1: TMenuItem;
    Enregistercettepartie1: TMenuItem;
    N4: TMenuItem;
    actCancel: TAction;
    Annuler1: TMenuItem;
    N5: TMenuItem;
    Memo1: TMemo;

    procedure FormCreate(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);

    procedure GrilleDrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure GrilleSelectCell(Sender: TObject; ACol, ARow: Integer;
      var CanSelect: Boolean);

    procedure actQuitExecute(Sender: TObject);
    procedure actNewExecute(Sender: TObject);
    procedure act2JoueursExecute(Sender: TObject);
    procedure act1JoueurExecute(Sender: TObject);
    procedure act2ManchesExecute(Sender: TObject);
    procedure act3ManchesExecute(Sender: TObject);
    procedure act4ManchesExecute(Sender: TObject);
    procedure actSaveExecute(Sender: TObject);
    procedure actLoadExecute(Sender: TObject);
    procedure actCancelExecute(Sender: TObject);
    procedure actCancelUpdate(Sender: TObject);
    procedure actSaveUpdate(Sender: TObject);
    procedure actLoadUpdate(Sender: TObject);
  private
    { Dclarations prives }
    FGrille: TGrille;
    FScore: TScore;
    FTour: ShortInt;
    FIA,
    FGameSavedExists: Boolean;
    FDernierJeton: TJeton;

    OldGridProc: TWndMethod;
    procedure GridWndProc(var Message: TMessage);

    procedure InitGrille;
    procedure FinDeManche(Joueur: ShortInt);
    procedure InverserTour;
  public
    { Dclarations publiques }
  end;

var
  FormMain: TFormMain;
  ChuteJeton: Boolean;

implementation

{$R *.dfm}
{$R P4Jetons.res}

uses
  uLoadSave{$IFDEF IA},uIA{$ENDIF};
  
//------------------------------------------------------------------------------
// FormMain (TForm)
//------------------------------------------------------------------------------
procedure TFormMain.GridWndProc(var Message: TMessage);
begin
  // Intercepter un clic gauche pendant la chute d'un jeton
  if ChuteJeton and
    ((Message.Msg = WM_LBUTTONDOWN) or (Message.Msg = WM_LBUTTONUP))
  then
    Message.Result := 1   // Annuler le clic
  else
    OldGridProc(Message); // Retransmettre le message
end;
//------------------------------------------------------------------------------
procedure TFormMain.FormCreate(Sender: TObject);
begin
  OldGridProc := Grille.WindowProc;
  Grille.WindowProc := GridWndProc;

  FIA := False;
  NbManches := 3;
  FTour := ROUGE; InverserTour;      // Dpart donn  JAUNE
  FGameSavedExists := GameSavedExists;
{$IFNDEF IA}
  N2Joueurs1.Visible := False;
  N1JoueurIA1.Visible := False;
  N3.Visible := False;
{$ENDIF}
{$IFDEF DEBUG}
  Memo1.Visible := True;
{$ENDIF}
end;
//------------------------------------------------------------------------------
procedure TFormMain.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  if MancheEnCours(FGrille) then CanClose := ConfirmerAbandon;
end;
//------------------------------------------------------------------------------
procedure TFormMain.InverserTour;
var
  myBitmap: TBitmap;
begin
  FTour := -FTour;
  myBitmap := TBitmap.Create;
  try
    if FTour = JAUNE then
      myBitmap.LoadFromResourceName(hInstance, 'JETON_JAUNE')
    else
      myBitmap.LoadFromResourceName(hInstance, 'JETON_ROUGE');
    ImageTour.Picture.Assign(myBitmap);
    if FIA then ImageTour.Repaint;  // Forcer le paint pendant le MinMax
  finally
    myBitmap.Free;
  end;
end;
//------------------------------------------------------------------------------
procedure TFormMain.InitGrille;
var
  Col, Row: Byte;
begin
  for Col := 0 to MAX_COL do
    for Row := 0 to MAX_ROW do
      FGrille[Col, Row] := VIDE;
  Grille.Repaint;
end;
//------------------------------------------------------------------------------
procedure TFormMain.FinDeManche(Joueur: ShortInt);
begin
  if Joueur <> VIDE then
  begin
    Grille.Repaint;   // Forcer un paint pour afficher les jetons gagnants
    Inc(FScore[Joueur]);
  end;
  MsgFinManche(Joueur, FScore);
  lblScoreJaune.Caption := IntToStr(FScore[JAUNE]);
  lblScoreRouge.Caption := IntToStr(FScore[ROUGE]);
  InitGrille;
end;
//------------------------------------------------------------------------------
// Evnements Grille (TDrawGrid)
//------------------------------------------------------------------------------
// Dessin de la grille
//------------------------------------------------------------------------------
procedure TFormMain.GrilleDrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
var
  myBitmap: TBitmap;
begin
  myBitmap := TBitmap.Create;
  try
    case FGrille[ACol, ARow] of
      GAGNANT:  myBitmap.LoadFromResourceName(hInstance, 'JETON_VERT');
      JAUNE:    myBitmap.LoadFromResourceName(hInstance, 'JETON_JAUNE');
      ROUGE:    myBitmap.LoadFromResourceName(hInstance, 'JETON_ROUGE');
      else      myBitmap.LoadFromResourceName(hInstance, 'JETON_VIDE');
    end;
    with Grille do
    begin
      Canvas.StretchDraw(Rect, myBitmap);
    end;
  finally
    myBitmap.Free;
  end;
end;
//------------------------------------------------------------------------------
// Slection d'une cellule
//------------------------------------------------------------------------------
procedure TFormMain.GrilleSelectCell(Sender: TObject; ACol, ARow: Integer;
  var CanSelect: Boolean);
{$IFDEF IA}
var
  Dispo: Byte;
{$ENDIF}
  //-----------------------------------------------------------------
  procedure LacherJeton(Couleur: ShortInt);
  var
    Row, Dest : integer;
  begin
    ChuteJeton := True;
    Dest := PointDeChute(FGrille, ACol);
    for Row := 0 to Dest do begin
      FGrille[ACol, Row] := Couleur;
      TDrawGrid(Sender).Repaint;
      Sleep(80);
      FGrille[ACol, Row] := VIDE;
    end;
    FGrille[ACol, Dest] := Couleur;
    // Sauvegarder ce dernier jeton pour un ventuel Cancel (Ctrl+Z)
    Annuler1.Caption := 'Annuler &dernier jeton';
    with FDernierJeton do begin
      X := ACol;
      Y := Dest;
      Joueur := Couleur;
    end;
    // ProcessMesages pour intercepter un vntuel clic pendant la chute
    Application.ProcessMessages;
    ChuteJeton := False;
  end;
  //-----------------------------------------------------------------
begin
  if (DispoCol(FGrille, ACol) = 0) then
    begin
      MsgColPleine;
      Exit;
    end
  else
  begin
    LacherJeton(FTour);
    if JoueurGagnant(FGrille, FTour) then
      FinDeManche(FTour);

{$IFDEF IA}
    // Si Appel de l'IA
    if (FTour = JAUNE) and FIA then
      begin
        Screen.Cursor := crHourGlass;
        InverserTour;
        // Rgler la profondeur de rflexion
        Dispo := DispoGrille(FGrille);
        if (Dispo < 18) then
          ACol := DecisionMinMax(FGrille, PROF_MAX)
        else
          ACol := DecisionMinMax(FGrille, PROF_MAX - 1);
        Screen.Cursor := crDefault;
        // Lacher jeton choisi
        LacherJeton(ROUGE);
        if JoueurGagnant(FGrille, ROUGE) then
          FinDeManche(ROUGE);
      end;
{$ENDIF}
  end;

  // Inverser le tour
  InverserTour;
  // Vrifier que la grille n'est pas pleine
  if DispoGrille(FGrille) = 0 then
    FinDeManche(VIDE);  // Match nul
end;


//------------------------------------------------------------------------------
// Actions
//------------------------------------------------------------------------------
procedure TFormMain.actQuitExecute(Sender: TObject);
begin
  Close;
end;
//------------------------------------------------------------------------------
procedure TFormMain.actNewExecute(Sender: TObject);
begin
  if MancheEnCours(FGrille) and ConfirmerAbandon then
  begin
    // Si IA avantage donn aux jaunes (humain)
    if FIA then FTour := ROUGE;
    InverserTour;
    InitGrille;
  end;
end;
//------------------------------------------------------------------------------
procedure TFormMain.act2JoueursExecute(Sender: TObject);
begin
  FIA := False;
end;
//------------------------------------------------------------------------------
procedure TFormMain.act1JoueurExecute(Sender: TObject);
begin
  FIA := True;
end;
//------------------------------------------------------------------------------
procedure DefNbManches(ctrl: TLabel; Value: ShortInt);
begin
  NbManches := Value;
  ctrl.Caption := '(' + IntToStr(Value) + ')';
end;
//------------------------------------------------------------------------------
procedure TFormMain.act2ManchesExecute(Sender: TObject);
begin
  DefNbManches(lblNbManches, 2);
end;
//------------------------------------------------------------------------------
procedure TFormMain.act3ManchesExecute(Sender: TObject);
begin
  DefNbManches(lblNbManches, 3);
end;
//------------------------------------------------------------------------------
procedure TFormMain.act4ManchesExecute(Sender: TObject);
begin
  DefNbManches(lblNbManches, 4);
end;
//------------------------------------------------------------------------------
procedure TFormMain.actSaveExecute(Sender: TObject);
begin
  SaveGame(FGrille, FScore, FDernierJeton, FIA);
end;
//------------------------------------------------------------------------------
procedure TFormMain.actSaveUpdate(Sender: TObject);
begin
  TAction(Sender).Enabled := (FScore[JAUNE] > 0) or (FScore[ROUGE] > 0) or
                             MancheEnCours(FGrille);
end;
//------------------------------------------------------------------------------
procedure TFormMain.actLoadExecute(Sender: TObject);
begin
  if not MancheEnCours(FGrille) or ConfirmerAbandon then
  begin
    LoadGame(FGrille, FScore, FDernierJeton, FIA);
    if FIA then act1Joueur.Execute;
    Grille.Repaint;
    FTour := FDernierJeton.Joueur;
    InverserTour;
    lblScoreJaune.Caption := IntToStr(FScore[JAUNE]);
    lblScoreRouge.Caption := IntToStr(FScore[ROUGE]);
    DefNbManches(lblNbManches, NbManches);
  end;
end;
//------------------------------------------------------------------------------
procedure TFormMain.actLoadUpdate(Sender: TObject);
begin
  // Action dispo si fichier de sauvegarde prsent
  TAction(Sender).Enabled := FGameSavedExists;
end;
//------------------------------------------------------------------------------
procedure TFormMain.actCancelExecute(Sender: TObject);
begin
  // Annuler/restaurer le dernier jeton jou
  with FDernierJeton do
  begin
    if FGrille[X, Y] = VIDE then
      begin
        FGrille[X, Y] := Joueur;
        TAction(Sender).Caption := 'Annuler &dernier jeton';
      end
    else
      begin
        FGrille[X, Y] := VIDE;
        TAction(Sender).Caption := 'Restaurer &dernier jeton';
      end;
  end;

  Grille.Repaint;
  InverserTour;
end;
//------------------------------------------------------------------------------
procedure TFormMain.actCancelUpdate(Sender: TObject);
begin
  // La suppression/restauration du dernier jeton jou n'est pas dispo avec l'IA
  TAction(Sender).Enabled := MancheEnCours(FGrille) and not FIA;
end;

end.
